#include <string.h>
#include <ctype.h>

int ismatch(const char *pat, const char *fn){
	char *p,*q;
	p=pat; q = fn;
	while(*p){
		//printf("%d,%d\n",*p,*q);
		if(!*q) return 0;
		if(*p=='?'){
			p++; q++;
		}else if(*p=='*'){
			p++;
			if(!*p){
				return 1;
			}else{
				for(; *q && toupper(*q)!=toupper(*p); q++);
				if(!*q) return 0;
			}
		}else if(toupper(*p++) != toupper(*q++)){
			return 0;
		}
	}
	if(*q)
		return 0;
	else
		return 1;
}

int fnsplit(const char *path, char *dir, char *fn){
	char *p,*save;
	
	for(p=path; *p; p++);
	for(p--; *p!='/' && p>path; p--);
	if(*p=='/'){
		save = ++p;
		for(; *p; p++,fn++) *fn = *p;
		*fn = 0;
		for(p=path; p<save; p++,dir++) *dir = *p;
		*dir = 0;
		return 1;
	}else{
		*dir = 0;
		for(p=path; *p; p++,fn++) *fn = *p;
		*fn = 0;
		return 0;
	}
}

#ifdef TEST
#include <stdio.h>

void matchtest(const char *pat, const char *file){
	int r;
	char dir[20],fn[13];
	fnsplit(pat,dir,fn);
	printf("dir,fn=%s,%s\n",dir,fn);
	r = ismatch(fn,file);
	printf("pat,file,match=%s,%s,%d\n",fn,file,r);
}

int main(){
	matchtest("/ram0/*.txt","hoge.txt");
	matchtest("/ram0/*.txt","hoge.elf");
	matchtest("/ram0/*.*","hoge.elf");
	matchtest("?oge.?x?","HOGE.TXT");
	matchtest("*","hoge.txt");
	matchtest("h*t","HOGE.TXT");
	matchtest("?d","wdir.elf");
	matchtest("*t","hoge.elf");
	matchtest("*t","et.elf");
}

#endif
